﻿#ifndef INSTALLINGFRAME_H
#define INSTALLINGFRAME_H

#include <QObject>
#include <QWidget>
#include <QProgressBar>
#include <QLabel>
#include <QTimer>
#include "../PluginService/ui_unit/arrowtooltip.h"
#include "../PluginService/ui_unit/middleframemanager.h"
#include "./uilt/slidershow.h"
#include "./uilt/showprogressbar.h"
#include "finishedInstall.h"
//#include "uilt/progressbarframe.h"


namespace KInstaller {
class InstallingFrame : public QWidget
{
    Q_OBJECT
public:
    explicit InstallingFrame(QWidget *parent = nullptr);
    ~InstallingFrame();
    void initUI();
    void addStyleSheet();
    void translateStr();
    void initAllConnect();
    void clickNextButton();


signals:
    void signalFinished();

public slots:
    void updateProgressValue(int value);
    void findFile();
    void showToopTipValue(int value);
    void closeW();

private:
    void changeEvent(QEvent *event);
public:
    QLabel* littleTitle;
    QProgressBar *m_installProgressBar;
    QLabel* m_mainTitle;
    ArrowWidget* w;
    SlideShow* slide;
    ShowProgressBar* progressBarCtrl;
    QTimer* timer, *timer1;
    int tmpvalue;
};
}

#endif // INSTALLINGFRAME_H
