﻿#ifndef USERFRAME_H
#define USERFRAME_H

#include <QObject>
#include <QWidget>
#include <QFile>
#include <QTextStream>
#include <QLabel>
#include <QEvent>
#include <QCheckBox>
#include "checkedlineedit.h"
#include "clineeditlabel.h"
#include "../PluginService/ui_unit/arrowtooltip.h"
#include "../PluginService/ui_unit/middleframemanager.h"

namespace KInstaller {

enum class LabelState {
    Username,
    Hostname,
    Pwd,
    CPwd,
    unkown
};

class UserFrame : public MiddleFrameManager
{
    Q_OBJECT
public:
    explicit UserFrame(QWidget *parent = nullptr);
    ~UserFrame();
    void initUI();
    void initAllConnect();
    void addStyleSheet();
    void translateStr();
    void writeSettingIni();
    void setNextBtnStyle(); //检测下一步按钮的状态显示

    QString getErrorMsg();
    void setBoardTabOrder();
signals:
    void signalCorrectFlag(LabelState state, bool flag);
    void signalConfirmPasswd();




public slots:

    void setComputerText();
    void showToolTip();
    void checkUserName(QString m_username);
    void checkHostName(QString m_hostname);
    void checkPasswd(QString pwd);
    void checkCPasswd(QString cpwd);
    void recheckCPasswd(QString pwd, QString cpwd);
    void markLineEditCorrect(LabelState state, bool flag);
    bool findFingerPrintDevice();

    void getAutoLogin();
    void clickNextButton();
private:
    void changeEvent(QEvent *event);
    void keyPressEvent(QKeyEvent *event);
//    bool eventFilter(QObject *watched, QEvent *event);
private:
    QLabel *m_cpwdErrorTip = nullptr;

    CLineEditLabel *m_username = nullptr;
    CLineEditLabel *m_hostname = nullptr;
    CLineEditLabel *m_passwd = nullptr;
    CLineEditLabel *m_confirm_passwd = nullptr;
    QLabel *m_userCheck = nullptr;
    QLabel *m_hostCheck = nullptr;
    QLabel *m_pwdCheck = nullptr;
    QLabel *m_cpwdCheck = nullptr;

    QLabel* fingerprintpng = nullptr;
    QLabel* fingerprinttip = nullptr;
    bool userSetFinished, hostSetFinished, pwdSetFinished, cpwdSetFinished;

    QString str_username = nullptr;
    QString str_hostname = nullptr;
    QString str_password = nullptr;
    QString str_confirm_password = nullptr;

    QLabel* m_mainTitle = nullptr;
    QString errstr, errtip;

    QCheckBox* autoLoginCKBox = nullptr;
    QCheckBox* pwLoginCKBox = nullptr;
    bool m_autoLoginFlag = false;
    QButtonGroup* btnGroup = nullptr;
    ArrowWidget *w = nullptr;
    QString tooltipStr = "";
    CheckState m_state ;
    LabelState m_LabelState ;
    bool m_flag = false;
    bool blfinger = false;

};
}
#endif // USERFRAME_H
